﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Diagnostics;
using System.Collections;
using System.Text;
using System.IO;
using System.Threading;
using System.Runtime.Serialization.Json;
using System.Runtime.Serialization;
using System.Collections.Generic;

/*
 * NOT USED!!
 */
namespace Librarian.model
{
    public class BookData
    {
        public bool results = false;
        public List<Book> bookList = new List<Book>();

        public void Search(int type, string queryString)
        {
            this.results = false;
            string webQueryURL;
            WebClient client = new WebClient();

            Debug.WriteLine("type = " + type);

            webQueryURL = "http://data.kirjastot.fi/search/";
            switch (type)
            {
                case 1: // author
                    webQueryURL += "author.json?query=" + queryString;
                    break;
                case 2: // title
                    webQueryURL += "title.json?query=" + queryString;
                    break;
                case 3: // isbn
                    webQueryURL += "isbn.json?query=" + queryString;
                    break;
                default:
                    break;
            }

            // attach a method to call when search results are available
            client.OpenReadCompleted += this.OnSearchResults;

            client.OpenReadAsync(new Uri(webQueryURL, UriKind.Absolute));


            return;
        }

        private List<Book> ParseJSON(string json)
        {
            List<Book> ret = new System.Collections.Generic.List<Book>();
            ret.Clear();
            int index = 0;
            int first = 0;
            int last = 0;
            first = json.IndexOf("\"type\":\"book\"");
            last = json.Length - 1;

            // we might have some meaningful results
            if (last - first > 2)
            {
                string str = json;
                // find the next book
                while (!(first == -1 || last == -1))
                {
                    first = -1;
                    first = str.IndexOf("\"type\":\"book\"");
                    if (!(first == -1 || last == -1))
                    {   // parse the next book
                        string toparse;
                        Book newbook = new Book();
                        first = str.IndexOf("\"isbn\":");
                        toparse = str.Substring(first + 8);
                        last = toparse.IndexOf("\"");
                        newbook.isbn = toparse.Substring(0, last);

                        first = str.IndexOf("\"title\":");
                        toparse = str.Substring(first + 9);
                        last = toparse.IndexOf("\"");
                        newbook.title = toparse.Substring(0, last);

                        first = str.IndexOf("\"library_id\":");
                        toparse = str.Substring(first + 14);
                        last = toparse.IndexOf("\"");
                        newbook.library_id = toparse.Substring(0, last);

                        first = str.IndexOf("\"library_url\":");
                        toparse = str.Substring(first + 15);
                        last = toparse.IndexOf("\"");
                        newbook.library_url = toparse.Substring(0, last);

                        first = str.IndexOf("\"author\":");
                        toparse = str.Substring(first + 10);
                        last = toparse.IndexOf("\"");
                        newbook.author = toparse.Substring(0, last);

                        if (newbook.author.Equals("ull,"))
                            newbook.author = "[not found]";

                        if (newbook.isbn.Equals("ull,"))
                            newbook.isbn = "[not found]";

                        newbook.author = "By "+newbook.author;

                        str = toparse;

                        ret.Add(newbook);
                    }
                }

            }
            return ret;
            // public string author
            // public string isbn
            // public string library_id
            // public string library_url
            ///public string title
        }

        private void OnSearchResults(object sender, OpenReadCompletedEventArgs e)
        {
            Stream reply;
            StreamReader s;

            reply = (Stream)e.Result;
            s = new StreamReader(reply);

            string str = s.ReadToEnd();

            this.bookList = ParseJSON(str);

            foreach (Book book in bookList)
            {
                Debug.WriteLine("-----");
                Debug.WriteLine("Book Title: " + book.title);
                Debug.WriteLine("Author: " + book.author);
                Debug.WriteLine("ISBN: " + book.isbn);
                Debug.WriteLine("url: " + book.library_url);
                Debug.WriteLine("id: " + book.library_id);
                Debug.WriteLine("-----");
            }


            this.results = true;

            Debug.WriteLine("I got results!");

            // and switch to results screen here?
        }
    }
}
