﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Librarian.model;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Threading;

namespace Librarian.pages
{
    public partial class BookInfo : PhoneApplicationPage
    {
        IDictionary<string, string> libraryAddress = new Dictionary<string, string>();
        IDictionary<string, double> libraryLat = new Dictionary<string, double>();
        IDictionary<string, double> libraryLon = new Dictionary<string, double>();
        IDictionary<string, string> libraryStatus = new Dictionary<string, string>();
        IDictionary<string, Color> libraryCol = new Dictionary<string, Color>();

        String title = string.Empty;
        String isbn = string.Empty;
        String author = string.Empty;
        String library_id = string.Empty;
        String library_url = string.Empty;
        String result = string.Empty;
        public PopUp popup = null;

        MapManager mapManager;

        public BookInfo()
        {
            InitializeComponent();
            initLibraryAddresses();
        }

        private void initLibraryAddresses()
        {
            // a list of some libraries addresses
            libraryAddress.Add("Etelä-Haaga adu", "Isonnevantie 16");
            libraryLat.Add("Etelä-Haaga adu", 60.2143944775096);
            libraryLon.Add("Etelä-Haaga adu", 24.8923904961324);

            libraryAddress.Add("Kannelmäki adu", "Klaneettitie 5");
            libraryLat.Add("Kannelmäki adu", 60.2389694981433);
            libraryLon.Add("Kannelmäki adu", 24.874635419385);

            libraryAddress.Add("Herttoniemi adu", "Kettutie 8");
            libraryLat.Add("Herttoniemi adu", 60.2070520241519);
            libraryLon.Add("Herttoniemi adu", 25.0386863179649);

            libraryAddress.Add("Arabianranta adu", "Hameentie 135");
            libraryLat.Add("Arabianranta adu", 60.2084317223642);
            libraryLon.Add("Arabianranta adu", 24.9753807096426);

            libraryAddress.Add("Itäkeskus adu", "Turunlinnantie 1");
            libraryLat.Add("Itäkeskus adu", 60.2137729302952);
            libraryLon.Add("Itäkeskus adu", 25.0839431514054);

            libraryAddress.Add("Jakomäki adu", "Jakomäenkuja 3");
            libraryLat.Add("Jakomäki adu", 60.2607919525415);
            libraryLon.Add("Jakomäki adu", 25.0758681602592);

            libraryAddress.Add("Kallio adu", "Viides linja 11");
            libraryLat.Add("Kallio adu", 60.1833239469753);
            libraryLon.Add("Kallio adu", 24.9527078966928);

            libraryAddress.Add("Kontula adu", "Ostostie 4");
            libraryLat.Add("Kontula adu", 60.2383616113072);
            libraryLon.Add("Kontula adu", 25.0837860570545);

            libraryAddress.Add("Kulosaari adu", "Kyösti Kallion tie 1");
            libraryLat.Add("Kulosaari adu", 60.1860901735891);
            libraryLon.Add("Kulosaari adu", 25.0103598159296);

            libraryAddress.Add("Käpylä adu", "Väinölänkatu 5");
            libraryLat.Add("Käpylä adu", 60.2107608168712);
            libraryLon.Add("Käpylä adu", 24.9468356415539);

            libraryAddress.Add("Laajasalo adu", "Koulutanhua 2");
            libraryLat.Add("Laajasalo adu", 60.1788023617447);
            libraryLon.Add("Laajasalo adu", 25.0555893286134);

            libraryAddress.Add("Lauttasaari adu", "Pajalahdentie 10");
            libraryLat.Add("Lauttasaari adu", 60.1590631150434);
            libraryLon.Add("Lauttasaari adu", 24.8855671371516);

            libraryAddress.Add("Malmi adu", "Ala-Malmin tori 1");
            libraryLat.Add("Malmi adu", 60.2506559518132);
            libraryLon.Add("Malmi adu", 25.0137236840958);

            libraryAddress.Add("Malminkartano adu", "Puustellintie 6");
            libraryLat.Add("Malminkartano adu", 60.2465851590679);
            libraryLon.Add("Malminkartano adu", 24.8602783617496);

            libraryAddress.Add("Maunula adu", "Suursuonlaita 6");
            libraryLat.Add("Maunula adu", 60.2342020261027);
            libraryLon.Add("Maunula adu", 24.9333494330377);

            libraryAddress.Add("Munkkiniemi adu", "Riihitie 22");
            libraryLat.Add("Munkkiniemi adu", 60.1969228536127);
            libraryLon.Add("Munkkiniemi adu", 24.8755182213352);

            libraryAddress.Add("Oulunkylä adu", "Kylänvanhimmantie 27");
            libraryLat.Add("Oulunkylä adu", 60.2280411954713);
            libraryLon.Add("Oulunkylä adu", 24.9625092181517);

            libraryAddress.Add("Paloheinä adu", "Paloheinäntie 22");
            libraryLat.Add("Paloheinä adu", 60.249522140411);
            libraryLon.Add("Paloheinä adu", 24.941740320433);

            libraryAddress.Add("Pasila adu", "Rautatieläisenkatu 8");
            libraryLat.Add("Pasila adu", 60.2009731557906);
            libraryLon.Add("Pasila adu", 24.9347393765338);

            libraryAddress.Add("Pitäjänmäki adu", "Jousipolku 1");
            libraryLat.Add("Pitäjänmäki adu", 66.3781689203934);
            libraryLon.Add("Pitäjänmäki adu", 28.7062161569585);

            libraryAddress.Add("Puistola adu", "Nurkkatie 2");
            libraryLat.Add("Puistola adu", 60.2706479155139);
            libraryLon.Add("Puistola adu", 25.0602287346071);

            libraryAddress.Add("Pukinmäki adu", "Kenttäkuja 12");
            libraryLat.Add("Pukinmäki adu", 60.2491054988716);
            libraryLon.Add("Pukinmäki adu", 24.9912643145575);

            libraryAddress.Add("Rikhardinkatu adu", "Rikhardinkatu 3");
            libraryLat.Add("Rikhardinkatu adu", 60.1662074929152);
            libraryLon.Add("Rikhardinkatu adu", 24.945908443374);

            libraryAddress.Add("Roihuvuori adu", "Roihuvuorentie 2");
            libraryLat.Add("Roihuvuori adu", 60.1942932307823);
            libraryLon.Add("Roihuvuori adu", 25.0530365454111);

            libraryAddress.Add("Suomenlinna adu", "Suomenlinna C 31");
            libraryLat.Add("Suomenlinna adu", 60.1548215675688);
            libraryLon.Add("Suomenlinna adu", 24.9593075669783);

            libraryAddress.Add("Suutarila adu", "Seulastentie 11");
            libraryLat.Add("Suutarila adu", 60.2752992743386);
            libraryLon.Add("Suutarila adu", 24.9964637960632);

            libraryAddress.Add("Tapanila adu", "Hiidenkiventie 21");
            libraryLat.Add("Tapanila adu", 60.2653613490963);
            libraryLon.Add("Tapanila adu", 25.0183477221639);

            libraryAddress.Add("Tapulikaupunki adu", "Ajurinaukio 5");
            libraryLat.Add("Tapulikaupunki adu", 60.274226934639);
            libraryLon.Add("Tapulikaupunki adu", 25.0342330346261);

            libraryAddress.Add("Töölö adu", "Topeliuksenkatu 6");
            libraryLat.Add("Töölö adu", 60.1838976828655);
            libraryLon.Add("Töölö adu", 24.9180805451481);

            libraryAddress.Add("Vallila adu", "Päijänteentie 5");
            libraryLat.Add("Vallila adu", 60.1921553815721);
            libraryLon.Add("Vallila adu", 24.9623128502131);

            libraryAddress.Add("Viikki adu", "Viikinkaari 11");
            libraryLat.Add("Viikki adu", 60.2269142142583);
            libraryLon.Add("Viikki adu", 25.0133446085969);

            libraryAddress.Add("Vuosaari adu", "Mosaiikkitori 2");
            libraryLat.Add("Vuosaari adu", 60.2084044016075);
            libraryLon.Add("Vuosaari adu", 25.1428057216726);

            //more
            libraryAddress.Add("Sello adu", "Kamreerintie 3 02770 Espoo");
            libraryLat.Add("Sello adu", 60.20443);
            libraryLon.Add("Sello adu", 24.65429);

            libraryAddress.Add("Pasila kirjavarasto 1", "Pasila");
            libraryLat.Add("Pasila kirjavarasto 1", 60.18371);
            libraryLon.Add("Pasila kirjavarasto 1", 24.95373);

            libraryAddress.Add("Tikkurila musiikkivarasto hel", "Kamreerintie 3 02770 Espoo");
            libraryLat.Add("Tikkurila musiikkivarasto hel", 60.29326);
            libraryLon.Add("Tikkurila musiikkivarasto hel", 25.03771);

        }

        private void loadInfo()
        {
            bookTitle.Text = title;
            bookISBN.Text = isbn;
            bookAuthor.Text = author;
            mapManager = new MapManager(myMap);
            mapManager.setZoom(10);

            //mapManager.centerOnLocation("Helsinki, Finland");

            Debug.WriteLine("INFO LOADED");


        }

        private void parseLibraryURL()
        {

            WebClient client = new WebClient();
            client.DownloadStringCompleted += ClientDownloadStringCompleted;

            Debug.WriteLine("reading url...: " + library_url);

            //string url = "http://www.helmet.fi/record=b1854574~S9*eng";
            client.DownloadStringAsync(new Uri(library_url, UriKind.Absolute));
        }

        private void ClientDownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            this.result = e.Result;
            //Thread thread = new Thread(threadFunction);
            // thread.Start(this);
            threadFunction(this);
        }

        public void threadFunction(Object thisObject)
        {
            BookInfo page;
            page = (BookInfo)thisObject;

            Debug.WriteLine("-----reading completed---");
            //handle the response.
            string s = @page.result;

            List<BookStatus> listBookStatus = new List<BookStatus>();

            int index = 0;
            string tmp = s;
            while ((index = tmp.IndexOf("<!-- field 1")) != -1)
            {
                int first;
                int last;
                string libraryname = "";
                string bookstatus = "";
                tmp = tmp.Substring(index);
                index = tmp.IndexOf("href");
                tmp = tmp.Substring(index);
                first = tmp.IndexOf(">");
                tmp = tmp.Substring(first + 1);
                last = tmp.IndexOf("<");
                if (!(first == -1 || last == -1))
                {   // we're parsing ">libraryname<"
                    libraryname = tmp.Substring(0, last);
                }

                index = tmp.IndexOf("<!-- field %");
                tmp = tmp.Substring(index);
                first = tmp.IndexOf(">");
                tmp = tmp.Substring(first + 7);
                last = tmp.IndexOf("<");
                if (!(first == -1 || last == -1))
                {   // we're parsing ">bookstatus<"
                    bookstatus = tmp.Substring(0, last - 1);
                }

                if (!(bookstatus == "" || libraryname == ""))
                {
                    BookStatus bs = new BookStatus();
                    bs.library = libraryname;
                    bs.status = bookstatus;
                    listBookStatus.Add(bs);
                }
            }

            foreach (BookStatus bs in listBookStatus)
            {
                double unused;
                if (libraryLat.TryGetValue(bs.library, out unused))
                {
                    if (bs.status.StartsWith("ON"))
                    {
                        if (!libraryCol.ContainsKey(bs.library))
                        {
                            libraryCol.Add(bs.library, Colors.Green);
                            libraryStatus.Add(bs.library, bs.status);
                        }
                        else
                        {
                            Debug.WriteLine("ERROR: " + bs.library);
                        }
                    }
                    else if (bs.status.StartsWith("DUE"))
                    {
                        if (!libraryCol.ContainsKey(bs.library))
                        {
                            libraryCol.Add(bs.library, Colors.Yellow);
                            libraryStatus.Add(bs.library, bs.status);
                        }
                        else
                        {
                            Debug.WriteLine("ERROR: " + bs.library);
                        }
                    }
                }
            }

            foreach (KeyValuePair<string, double> kvp in libraryLat)
            {
                double lat = kvp.Value;
                double lon;
                if (libraryLon.TryGetValue(kvp.Key, out lon))
                {

                    // TODO: somehow match the library name with the availability data and adjust the color and the string
                    Color curcolor; // color from results or red if not found in results
                    // TODO: get due dates
                    string status = "available";
                    if (!libraryCol.TryGetValue(kvp.Key, out curcolor))
                    {
                        
                        curcolor = Colors.Red; // red
                        if (!libraryStatus.TryGetValue(kvp.Key, out status))
                            status = "not available"; // available / due xxxx-xx-xx / not available
                    }
                    else
                    {
                        libraryStatus.TryGetValue(kvp.Key, out status);
                        Debug.WriteLine("Library not in DB: "+kvp.Key);
                    }


                    //mapManager.addPushPin(lat, lon, curcolor, status);
                    mapManager.addPushPinV2(lat, lon, curcolor, kvp.Key+"\n"+status);
                }
            }

            Dispatcher.BeginInvoke(() =>
            {
                try
                {
                    Thread.Sleep(1800);
                    page.popup.Visibility = Visibility.Collapsed;
                    page.LayoutRoot.Children.Remove(popup);
                }
                catch (Exception) { }
            });

        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (this.NavigationContext != null)
            {
                this.NavigationContext.QueryString.TryGetValue("title", out title);
                this.NavigationContext.QueryString.TryGetValue("isbn", out isbn);
                this.NavigationContext.QueryString.TryGetValue("author", out author);
                this.NavigationContext.QueryString.TryGetValue("library_id", out library_id);
                this.NavigationContext.QueryString.TryGetValue("library_url", out library_url);
            }

            popup = new PopUp();
            LayoutRoot.Children.Add(popup);
            popup.pop.Visibility = Visibility.Visible;

            parseLibraryURL();
            loadInfo();
        }
    }
}