﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Net.NetworkInformation;

namespace Librarian.pages
{
    public partial class SearchPage : PhoneApplicationPage
    {
        public SearchPage()
        {
            InitializeComponent();
            searchButton.Click += new RoutedEventHandler(searchButton_Pressed);
            searchbox.GotFocus += new RoutedEventHandler(searchbox_GotFocus);
            helpButton.Click += new RoutedEventHandler(helpButton_Click);
        }

        void helpButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/pages/HelpPage.xaml?", UriKind.Relative));
        }

        void searchbox_GotFocus(object sender, RoutedEventArgs e)
        {
            if (searchbox.Text.Equals("search "))
                searchbox.Text = "";
        }

        public void searchButton_Pressed(object sender, RoutedEventArgs e)
        {
            if (!InternetIsAvailable())
            {
                return;
            }
            String type = "1";
            if (rb1.IsChecked.Value){
                type = "1";
            }
            else if (rb2.IsChecked.Value)
            {
                type = "2";
            }
            else if (rb3.IsChecked.Value)
            {
                type = "3";
            }

            NavigationService.Navigate(new Uri("/pages/SearchResults.xaml?text=" + searchbox.Text + "&type=" + type, UriKind.Relative));
        }

        public bool InternetIsAvailable()
        {
            var available = NetworkInterface.GetIsNetworkAvailable();
            if (!available)
            {
                MessageBox.Show("No internet connection available. Connect to network and try again!");
                return false;
            }
            return true;
        }
    }
    
}